local frame = CreateFrame("Frame")
local QuestItemKeybound = LibStub("AceAddon-3.0"):NewAddon(frame, "QuestItemKeybound", "AceEvent-3.0")

local LQI = LibStub("LibQuestItem-1.0", true)

--SETTINGS
local keyToBind = "ALT-Q"
local displayChatMessage = true
--SETTINGS

local spellBound
local spellToBind

local function BindItem()
	if not spellToBind or InCombatLockdown() then return end
	
	local spellItem = LQI.questItemSpells[spellToBind]
	if spellItem then
		local itemName = GetItemInfo(spellItem) 
		SetOverrideBindingItem(QuestItemKeybound, true, keyToBind, itemName)
		spellBound = spellToBind
		if displayChatMessage then
			print("QuestItemKeyBound: Bound item "..itemName.." to key "..keyToBind..".")
		end
	end
	spellToBind = nil
end

function QuestItemKeybound:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function QuestItemKeybound:PLAYER_REGEN_ENABLED()
	BindItem()
end

function QuestItemKeybound:UNIT_SPELLCAST_SUCCEEDED(_, unitID, spell)
	if unitID and unitID == "player" and LQI.questItemSpells[spell] and spell ~= spellBound then
		spellToBind = spell
		BindItem()
	end
end